	.386
	.model flat,stdcall
	option casemap:none, dotname

	include windows.inc
	include user32.inc
	include kernel32.inc
	include gdi32.inc

	includelib user32.lib
	includelib kernel32.lib
	includelib gdi32.lib
	
	include masm32.inc
	includelib masm32.lib

	include Switch.Inc
	include GradScrollBar.Inc
include \masm32\macros\macros.asm
.code

RegisterProgress PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX

	mov		eax,hInst
	mov		wc.hInstance,eax
	mov		wc.cbSize,SIZE WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS
	mov		wc.lpfnWndProc,OFFSET GradProgressProc
	mov		wc.cbWndExtra,PWL_EXTRASIZE
	xor		eax,eax
	mov		wc.cbClsExtra,eax
	mov		wc.hIcon,eax
	mov		wc.hCursor,eax
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,eax
	mov		wc.hIconSm,eax
	mov		wc.lpszClassName,offset ProgClassName
	invoke	RegisterClassExA,ADDR wc
	ret

RegisterProgress ENDP

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

	invoke RegisterProgress,hInst
	push    hInst
	pop     hInstance
	mov     eax,TRUE
	ret

DllEntry Endp

;NOTE: RadASM 1.2.0.5 uses this method.
;In RadASM.ini section [CustCtrl], x=CustCtrl.dll,y
;x is next free number.
;y is number of controls in the dll. In this case there is only one control.
;
;x=GradProgress.dll,1
;
;Copy GradProgress.dll to c:\windows\system
;
GetDef proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_GRADPROGRESS
		mov		ccdef.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdef
	.else
		xor		eax,eax
	.endif
	ret

GetDef endp

;--------------------------------------------------------------------------------

GradFill PROC USES ebx esi edi, DC:DWORD, lpRect:DWORD, Color1:DWORD, Color2:DWORD, FullLength:DWORD
	LOCAL	dx1:DWORD, dx2:DWORD, dx3:DWORD
	LOCAL	TmpRect:RECT

	;calc width of rectangle, copy rectangle
	mov		esi,lpRect
	mov		ebx,[esi].RECT.right
	sub		ebx,[esi].RECT.left
	jz		@F
	lea		edi,TmpRect
	mov		ecx,(SIZE RECT)/4
	rep movsd
	;prepare tmprect
	mov		eax,TmpRect.left
	inc		eax
	mov		TmpRect.right,eax

	mov		ecx, Color2
	mov		edi, Color1
	sal		ecx, 7
	sal		edi, 7

	mov		eax, ecx
	mov		ebx, edi
	and		eax, 0FF000000h / 2
	and		ebx, 0FF000000h / 2
	sub		eax, ebx
	cdq
	idiv	FullLength
	mov		dx1, eax

	mov		eax, ecx
	mov		esi, edi
	and		eax, 0FF0000h / 2
	and		esi, 0FF0000h / 2
	sub		eax, esi
	cdq
	idiv	FullLength
	mov		dx2, eax

	mov		eax, ecx
	and		eax, 0FF00h / 2
	and		edi, 0FF00h / 2
	sub		eax, edi
	cdq
	idiv	FullLength
	mov		dx3, eax

	mov		eax, Color1
lp: ;fill tmprect
	invoke	CreateSolidBrush,eax
	push	eax
	lea		edx,TmpRect
	invoke	FillRect,DC,edx,eax
	pop		eax
	invoke	DeleteObject,eax
	;update tmprect
	inc		TmpRect.left
	inc		TmpRect.right

	add	ebx,dx1
	mov	eax,ebx
	and	eax,0FF000000h / 2

	add	esi,dx2
	mov	edx,esi
	and	edx,0FF0000h / 2
	or	eax,edx

	add	edi,dx3
	mov	edx,edi
	and	edx,0FF00h / 2
	or	eax,edx

	shr	eax, 7

	dec	FullLength
	jne	lp
	
@@:	ret

GradFill ENDP

GradProgressProc PROC USES ebx esi edi, HWnd:DWORD, WMsg:DWORD, WParam:DWORD, LParam:DWORD
	LOCAL Tmp:DWORD

	;Switch macro operates on value in eax
	mov		eax, WMsg
	.switch
		.case	WM_PAINT,			_WM_PAINT
		.case	WM_CREATE,			_WM_CREATE
		.case	WM_DESTROY,			_WM_DESTROY
		.case	WM_SIZE,			_WM_SIZE
		.case	WM_LBUTTONDOWN, 	_WM_LBUTTONDOWN 
		.case	WM_MOUSEMOVE,		_WM_MOUSEMOVE
		.case	WM_TIMER,			_WM_TIMER
		;handle custom progress bar messages
		.case	RB_SETSIZEBAR,		_RB_SETSIZEBAR		
		.case	RB_SETBARCOLOR1,	_RB_SETBARCOLOR1
		.case	RB_SETBARCOLOR2,	_RB_SETBARCOLOR2
		.case	RB_SETBARCOLORS,	_RB_SETBARCOLORS
		.case	RB_SETRANGE,		_RB_SETRANGE
		.case	RB_SETPOS,			_RB_SETPOS
		.case	RB_GETBARCOLOR1,	_RB_GETBARCOLOR1
		.case	RB_GETBARCOLOR2,	_RB_GETBARCOLOR2
		.case	RB_GETRANGE,		_RB_GETRANGE
		.case	RB_GETPOS,			_RB_GETPOS
		.case	RB_RANDOMCOLOR,	_RB_RANDOMCOLOR
		.case	RB_RAINIT,			_RB_RAINIT
		.default _DefProgProc
	.endswitch NULL_MACRO

GradProgressProc ENDP

End DllEntry
